From 94d3cb25efe3ec9c21fa05a2666afc06b4b46c54 Mon Sep 17 00:00:00 2001
From: basos g <noxelia 4t gmail d0t c0m>
Date: Wed, 11 Feb 2009 15:31:04 +0200
Subject: [PATCH] var_OptionParse was made quote aware

Added str_dequote. var_optionParse now dequotes strings

var_optionParse that is used from input thread Create to parse
input options dequotes them before adding them to input thread.
During dshow debuging it was found that quotes were not
needed as a part of the variables values, and problems
(unrecognized devices) arized from there. I am not sure
that quotes are not needed elsewere but i think its not the
case. Afterall why were quotes added? The option delimiter
is an = sign.
---
 include/vlc_strings.h |   12 ++++++++++++
 src/misc/variables.c  |    4 ++++
 2 files changed, 16 insertions(+), 0 deletions(-)

diff --git a/include/vlc_strings.h b/include/vlc_strings.h
index eab608e..df0d6df 100644
--- a/include/vlc_strings.h
+++ b/include/vlc_strings.h
@@ -53,6 +53,18 @@ VLC_EXPORT( char *, __str_format, ( vlc_object_t *, const char * ) );
 VLC_EXPORT( void, filename_sanitize, ( char * ) );
 VLC_EXPORT( void, path_sanitize, ( char * ) );
 
+
+static inline char * str_dequote( char * psz_value )
+{
+     /* check for quoted string and unquote it */
+     char *p_valend ;
+     if ( psz_value[0] == '"' && ( p_valend = strchr ( psz_value + 1, '"' ) ) )
+     {
+         psz_value++ ;
+         *p_valend = '\0' ;
+     }
+     return psz_value ;
+}
 /**
  * @}
  */
diff --git a/src/misc/variables.c b/src/misc/variables.c
index be81856..49a2d66 100644
--- a/src/misc/variables.c
+++ b/src/misc/variables.c
@@ -29,6 +29,8 @@
 #endif
 
 #include <vlc_common.h>
+#include <vlc_strings.h>
+
 #include "variables.h"
 
 #include "libvlc.h"
@@ -1085,6 +1087,8 @@ void var_OptionParse( vlc_object_t *p_obj, const char *psz_option,
     case VLC_VAR_MODULE:
     case VLC_VAR_FILE:
     case VLC_VAR_DIRECTORY:
+        /* check for quoted string and unquote it */
+        psz_value = str_dequote( psz_value ) ;
         val.psz_string = psz_value;
         break;
 
-- 
1.5.6.5

